﻿using UIKit;
using AudioToolbox;
using Foundation;
using System.Collections.Generic;

namespace Loop
{
	public class LoopSound
	{
		SystemSound[] _sound = new SystemSound[7];
		public List<int> _loop = new List<int>();
		int _current;
		UILabel _label;
		UIButton _button;

		public LoopSound(string name,UILabel label,UIButton button)
		{
			for (int i = 0; i < _sound.Length; i++)
			{
				var url = NSUrl.FromFilename("Sounds/" + name + i + ".wav");
				_sound[i] = new SystemSound(url);
			}
			_label = label;
			_button = button;
			_button.Enabled = false;
		}

		public void Add(int index)
		{
			if (_loop.Count == 0)
			{
				_label.Text = "";
				_button.Enabled = true;
				_current = 0;
			}
			_loop.Add(index);
			_sound[index].PlaySystemSound();
			_label.Text += index+",";
		}

		public void Play(int index=-1)
		{
			if (index < 0)
			{
				_button.Enabled = false;
				index = _loop[_current];
			}
			_sound[index].PlaySystemSound(() =>
			{
				_current++;
				if (_current < _loop.Count)
				{
					Play(_loop[_current]);
				}
				else
				{
					_loop.Clear();
				}
			});
		}
	}
}
